=== debian/changelog ===
chocolate-doom (3.1.1-1) unstable; urgency=medium

  * New upstream version 3.1.1
    + Fix compilation on GCC 15 (Closes: #1096433)
  * Bump Standards-Version to 4.7.2
  * Bump Debian packaging copyright year

 -- Fabian Greffrath <fabian@debian.org>  Thu, 21 Aug 2025 08:17:36 +0200
